﻿Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win
Imports Infragistics.Documents.Excel

Public Class Form1

    Private Sub UltraButton1_Click(sender As Object, e As EventArgs) Handles UltraButton1.Click
        Me.UltraGridExcelExporter1.Export(Me.UltraGrid1, Application.StartupPath + "GridData.xls")
        Process.Start(Application.StartupPath + "GridData.xls")

    End Sub

    Private Sub UltraGridExcelExporter1_ExportStarted(sender As Object, e As Infragistics.Win.UltraWinGrid.ExcelExport.ExportStartedEventArgs) Handles UltraGridExcelExporter1.ExportStarted
        Dim workBook As Workbook = New Workbook(WorkbookFormat.Excel2007)

        Dim workSheet As Worksheet = workBook.Worksheets.Add("Exported Grid Data")
        workBook.WindowOptions.SelectedWorksheet = workSheet
       
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        UltraGrid1.DataSource = GetEmployeeOptions()

        Dim band As UltraGridBand = Me.UltraGrid1.DisplayLayout.Bands(0)
        
    End Sub

    Private Function GetEmployeeOptions() As DataTable
        Dim dtData As New DataTable("EmployeeOptions")

        dtData.Columns.Add("OptionID", GetType(Integer))
        dtData.Columns.Add("Employee", GetType(Integer))
        dtData.Columns.Add("Option", GetType(String))
        dtData.Columns.Add("Description", GetType(String))


        For i As Integer = 0 To 95
            dtData.Rows.Add(New Object() {i, i Mod 24, String.Format("Option {0}", i), [String].Format("Option Description {0}", i)})
        Next

        dtData.PrimaryKey = New DataColumn() {dtData.Columns("OptionID")}

        Return dtData
    End Function

    Private Sub UltraGridExcelExporter1_RowExporting(sender As Object, e As ExcelExport.RowExportingEventArgs) Handles UltraGridExcelExporter1.RowExporting

        'Group your rows.

        e.CurrentWorksheet.Rows(1).OutlineLevel = 1
        e.CurrentWorksheet.Rows(2).OutlineLevel = 1

        e.CurrentWorksheet.Rows(3).OutlineLevel = 2
       
        e.CurrentWorksheet.Rows(3).OutlineLevel = 2

        e.CurrentWorksheet.Rows(5).OutlineLevel = 3
        e.CurrentWorksheet.Rows(6).OutlineLevel = 3
    End Sub
End Class
